Getting Started with Splitter Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Splitter module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.splitter.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-splitter id="splitter"></smart-splitter>

    Host container (id matches appendTo on Smart.Splitter):

    <div id="splitterContainer"></div>

  5. Initialize after the module loads: define a const splitterOptions object, then either bind with Smart('#splitter', ...) on the semantic tag or use new Smart.Splitter({ ...splitterOptions, appendTo: '#splitterContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.splitter.js';
    
    	const splitterOptions = {
    				dataSource: [
    				{
    					id: 'item0',
    					size: '50%',
    					content: 'Item 1Item 2Item 3'
    				},
    				{
    					size: '25%',
    					id: 'item4',
    					content: 'Item 4',
    				},
    				{
    					id: 'item5',
    					content: 'Item 5'
    				}
    				]
    			};
    
    	// Option A - semantic <smart-splitter> with id="splitter"
    	Smart('#splitter', class {
    		get properties() {
    			return splitterOptions;
    		}
    	});
    
    	// Option B - host div id="splitterContainer"
    	// const splitterInstance = new Smart.Splitter({
    	// 	...splitterOptions,
    	// 	appendTo: '#splitterContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const mySplitter = new Smart.Splitter('#splitter', splitterOptions);
    	// document.body.appendChild(mySplitter);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Splitter('#splitter', splitterOptions) with appendChild, and document.createElement('smart-splitter') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Splitter({ ...options, appendTo: '#...' }); new Smart.Splitter('#splitter', splitterOptions) plus appendChild on the returned element; and document.createElement('smart-splitter') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const mySplitter = new Smart.Splitter('#splitter', splitterOptions)):

	const splitterOptions = {
				dataSource: [
				{
					id: 'item0',
					size: '50%',
					content: 'Item 1Item 2Item 3'
				},
				{
					size: '25%',
					id: 'item4',
					content: 'Item 4',
				},
				{
					id: 'item5',
					content: 'Item 5'
				}
				]
			};
	const mySplitter = new Smart.Splitter('#splitter', splitterOptions);
	document.body.appendChild(mySplitter);
	

Create with document.createElement('smart-splitter'), assign properties (same as any custom element), then append:

	const splitterOptions = {
				dataSource: [
				{
					id: 'item0',
					size: '50%',
					content: 'Item 1Item 2Item 3'
				},
				{
					size: '25%',
					id: 'item4',
					content: 'Item 4',
				},
				{
					id: 'item5',
					content: 'Item 5'
				}
				]
			};
	const splitter = document.createElement('smart-splitter');
	Object.assign(splitter, splitterOptions);
	document.body.appendChild(splitter);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.splitter.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const splitterOptions = {
				dataSource: [
				{
					id: 'item0',
					size: '50%',
					content: 'Item 1Item 2Item 3'
				},
				{
					size: '25%',
					id: 'item4',
					content: 'Item 4',
				},
				{
					id: 'item5',
					content: 'Item 5'
				}
				]
			};
		const splitter = new Smart.Splitter({
			...splitterOptions,
			appendTo: '#splitterContainer'
		});
	}
	

Adding Content

The content of the Splitter is nested inside Smart.SplitterItem(s). Splitter items can contain any HTML.

There are three ways to add content to a Smart.Splitter:

  • Create splitter items in the HTML code:
    <!DOCTYPE html>
    <html>
    <head>
     <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
     <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/webcomponentsjs/1.2.0/webcomponents-lite.js">
    </script> <script type="text/javascript" src="../../source/Smart.element.js"></script> <script type="text/javascript" src="../../source/Smart.button.js"></script> <script type="text/javascript" src="../../source/Smart.Splitter.js"></script> </head> <body> <smart-splitter> <smart-splitter-item> Content of Item 1 </smart-splitter-item> <smart-splitter-item> Content of item 2 </smart-splitter-item> </smart-splitter> </body> </html>

    Demo


  • Set the dataSource property to an Array that defines the internal stucture of the Splitter:
    <!DOCTYPE html>
    <html>
    <head>
     <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
     <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/webcomponentsjs/1.2.0/webcomponents-lite.js">
    </script> <script type="text/javascript" src="../../source/Smart.element.js"></script> <script type="text/javascript" src="../../source/Smart.button.js"></script> <script type="text/javascript" src="../../source/Smart.Splitter.js"></script> <script> window.onload = function() { const dataSource = [ { id: 'item0', size: 250, content: '<smart-splitter> ' + '<smart-splitter-item id="item1">Item 1</smart-splitter-item> ' + '<smart-splitter-item id="item2">Item 2</smart-splitter-item> ' + '<smart-splitter-item id="item3">Item 3</smart-splitter-item> ' + '</smart-splitter>' }, { id: 'item4', content: 'Item 4' }, { id: 'item5', content: 'Item 5', collapsible: true }]; document.querySelector('smart-splitter').dataSource = dataSource; } </script> </head> <body> <smart-splitter orientation="horizontal"></smart-splitter> </body> </html>
    All available Splitter item properties can be set in the object definition in the dataSource array. Collapsible is one of the properties that is set to the item with id 'item5'.

    Demo


  • Create splitter items via the API methods after element initialization:
    <!DOCTYPE html>
    <html>
    <head>
     <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
     <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/webcomponentsjs/1.2.0/webcomponents-lite.js">
    </script> <script type="text/javascript" src="../../source/Smart.element.js"></script> <script type="text/javascript" src="../../source/Smart.button.js"></script> <script type="text/javascript" src="../../source/Smart.Splitter.js"></script> <script> window.onload = function() { const item1 = document.createElement('smart-splitter-item'), item2 = document.createElement('smart-splitter-item'), item3 = document.createElement('smart-splitter-item'), splitter = document.querySelector('smart-splitter'); item1.innerHTML = 'Item 1 Content'; //Append the item to the end splitter.appendChild(item1); item2.innerHTML = 'Item 2 Content'; //Insert item2 before item1 splitter.insertBefore(item2, item1); item3.innerHTML = 'Item 3 Content'; //Insert item3 at position 1 splitter.insert(1, item3); //Splitter item object definition const item4 = { content: 'Item 4 Content', size: 100 }; //Insert method also accepts a Splitter Item object definition as it's second argument splitter.insert(0, item4) } </script> </head> <body> <smart-splitter></smart-splitter> </body> </html>

Demo

Updating

Splitter items can be updated after their initialization using the API methods and properties.

This can be done in one of the following ways:

  • By manipulating the Splitter Item directly. In order to do that the user needs a reference to the desired item:
        const splitter = document.querySelector('smart-splitter');
        const items = splitter.items;
        items[1].content = 'New Content';
        items[1].collapsible = true;
        items[1].collapse();
        items[1].expand();
        const bars = splitter.bars;
        bars[0].lock();
        bars[0].unlock();
        bars[1].hide();
    

    Demo

  • Taking adventage of the Splitter's API methods:
        const splitter = document.querySelector('smart-splitter');
        splitter.update(0, { content: 'New Content', collapsible: true });
        //Will work only if the item at position 0 is collapsible
        splitter.collapse(0);
        //Expands the item if there's space available
        splitter.expand(0);
        splitter.lockItem(1);
        splitter.unlockItem(1);
        splitter.lockBar(1);
        splitter.unlockBar(1);
        splitter.hideBar(0);
    

    Demo

Preferences

Splitter properties can be applied as attributes in the HTML before initialization or updated later using an instance of the element. The full list of all properties of the element can be found in the API documentation.

Setting properties before initialization:

<!DOCTYPE html>
<html>
<head>
 <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/webcomponentsjs/1.2.0/webcomponents-lite.js">
</script> <script type="text/javascript" src="../../source/Smart.element.js"></script> <script type="text/javascript" src="../../source/Smart.button.js"></script> <script type="text/javascript" src="../../source/Smart.Splitter.js"></script> </head> <body> <smart-splitter orientation="horizontal" resize-mode="end" live-resize> <smart-splitter-item min="20"> Content of Item 1 </smart-splitter-item> <smart-splitter-item> Content of item 2 </smart-splitter-item> <smart-splitter-item> <smart-splitter resize-mode="none"> <smart-splitter-item size="50%"> Content of Item 3 </smart-splitter-item> <smart-splitter-item> Content of Item 4 </smart-splitter-item> </smart-splitter> </smart-splitter-item> </smart-splitter> </body> </html>

Demo

Setting properties after intialiation:

<!DOCTYPE html>
<html>
<head>
 <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/webcomponentsjs/1.2.0/webcomponents-lite.js">
</script> <script type="text/javascript" src="../../source/Smart.element.js"></script> <script type="text/javascript" src="../../source/Smart.button.js"></script> <script type="text/javascript" src="../../source/Smart.Splitter.js"></script> <script> window.onload = function() { const splitter = document.querySelector('smart-splitter'); splitter.resizeMode = 'proportional'; splitter.orientaiton = 'horizontal'; splitter.resizeStep = 1; //Defualt is 5 } </script> </head> <body> <smart-splitter> <smart-splitter-item size="25%"> Content of item 1 </smart-splitter-item> <smart-splitter-item> Content of item 2 </smart-splitter-item> <smart-splitter-item size="25%"> Content of item 3 </smart-splitter-item> </smart-splitter> </body> </html>

Demo

The size of the splitter items can be set via CSS or the size property.

<!DOCTYPE html>
<html>
<head>
 <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/webcomponentsjs/1.2.0/webcomponents-lite.js">
</script> <script type="text/javascript" src="../../source/Smart.element.js"></script> <script type="text/javascript" src="../../source/Smart.button.js"></script> <script type="text/javascript" src="../../source/Smart.Splitter.js"></script> <style> #mySplitter smart-splitter-item:nth-of-type(1), #mySplitter smart-splitter-item:nth-of-type(3) { width: 25%; } </style> </head> <body> <smart-splitter id="mySplitter"> <smart-splitter-item> Content of item 1 </smart-splitter-item> <smart-splitter-item> Content of item 2 </smart-splitter-item> <smart-splitter-item> Content of item 3 </smart-splitter-item> </smart-splitter> </body> </html>

Demo

Keyboard Support

Smart.Splitter implements the following key actions:

Key Action
Arrow Up / Arrow Down Resizes the items on the two sides of the focused splitter bar. Used when the orientation of the Splitter is set to 'horizontal'.
Arrow Left / Arrow Right Resizes the items on the two sides of the focused splitter bar. Used when the orientation of the Splitter is set to 'vertical'.
Enter If liveResize is set to 'false' which is the case by default, the key is used to finish an ongoing resizing operation.
Escape Cancels an ongoing resizing operation.

Append to the DOM:

const container = document.getElementById('splitter-container');
container.appendChild(splitter);
	

Remove from the DOM:

splitter.remove();
	

Set a property:

splitter.disabled = true;
splitter.theme = 'dark';
	

Get a property value:

const isDisabled = splitter.disabled;
const currentTheme = splitter.theme;
	

Invoke a method:

splitter.refresh();
splitter.focus();
	

Add event listener:

splitter.addEventListener('collapse', (event) => {
    console.log('collapse triggered:', event.detail);
});
	

Remove event listener:

const handleSplitterEvent = (event) => {
    console.log('collapse triggered:', event.detail);
};

splitter.addEventListener('collapse', handleSplitterEvent);
splitter.removeEventListener('collapse', handleSplitterEvent);
	

Common Use Cases

  • Set panel sizes

    Configure initial panel dimensions

    splitter.dataSource = [
      { size: '30%', content: 'Left Panel' },
      { size: '70%', content: 'Right Panel' }
    ];
  • Handle resize

    Respond to panel size changes

    splitter.addEventListener('resize', (e) => {
      console.log('New sizes:', e.detail);
    });

Troubleshooting

How do I make panels collapsible?
Add collapsible: true to the panel configuration in dataSource.
How do I set minimum panel sizes?
Use min property in panel config: { size: '200px', min: '100px', content: '...' }.

Accessibility

The Splitter component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Splitter - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/splitter/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import SplitterModule from smart-webcomponents-angular/splitter: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { SplitterModule } from 'smart-webcomponents-angular/splitter';

4 Root component (standalone)

Add SplitterModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { SplitterComponent } from 'smart-webcomponents-angular/splitter';

import { SplitterModule } from 'smart-webcomponents-angular/splitter';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ SplitterModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('splitter', { read: SplitterComponent, static: false }) splitter!: SplitterComponent;


    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.

        this.splitter.dataSource = [
            {
                id: 'item0',
                size: '50%',
                content: '<smart-splitter>' +
                    '<smart-splitter-item size="33%" collapsible id="item1">Item 1</smart-splitter-item>' +
                    '<smart-splitter-item size="33%" id="item2">Item 2</smart-splitter-item>' +
                    '<smart-splitter-item collapsible id="item3">Item 3</smart-splitter-item>' +
                    '</smart-splitter>'
            },
            {
                size: '25%',
                id: 'item4',
                content: 'Item 4',
            },
            {
                id: 'item5',
                content: 'Item 5'
            }
        ];
    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-splitter as needed:

 <smart-splitter #splitter orientation="horizontal" id="horizontalSplitter"></smart-splitter>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put SplitterModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put SplitterModule from smart-webcomponents-angular/splitter on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { SplitterModule } from 'smart-webcomponents-angular/splitter';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, SplitterModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Set panel sizes

    Configure initial panel dimensions

    splitter.dataSource = [
      { size: '30%', content: 'Left Panel' },
      { size: '70%', content: 'Right Panel' }
    ];
  • Handle resize

    Respond to panel size changes

    splitter.addEventListener('resize', (e) => {
      console.log('New sizes:', e.detail);
    });

Troubleshooting

How do I make panels collapsible?
Add collapsible: true to the panel configuration in dataSource.
How do I set minimum panel sizes?
Use min property in panel config: { size: '200px', min: '100px', content: '...' }.

Accessibility

The Splitter component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Splitter Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/splitter/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { createRoot } from 'react-dom/client';
import { Splitter, SplitterItem } from 'smart-webcomponents-react/splitter';

const App = () => {
  // Called when the Splitter is ready
  const handleReady = () => {
    const container = document.getElementById('splitterContainer');
    if (!container) return;
    const root = createRoot(container);
    root.render(
      <Splitter>
        <SplitterItem size="33%" collapsible id="item1">Item 1</SplitterItem>
        <SplitterItem size="33%" id="item2">Item 2</SplitterItem>
        <SplitterItem collapsible id="item3">Item 3</SplitterItem>
      </Splitter>
    );
  };

  return (
    <div>
      <Splitter
        onReady={handleReady}
        orientation="horizontal"
        id="horizontalSplitter"
        dataSource={[
          {
            id: 'item0',
            size: '50%',
            content: '<div style="height: 100%;" id="splitterContainer"></div>'
          },
          {
            size: '25%',
            id: 'item4',
            content: 'Item 4',
          },
          {
            id: 'item5',
            content: 'Item 5'
          }
        ]}
      >
      </Splitter>
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Set panel sizes

    Configure initial panel dimensions

    splitter.dataSource = [
      { size: '30%', content: 'Left Panel' },
      { size: '70%', content: 'Right Panel' }
    ];
  • Handle resize

    Respond to panel size changes

    splitter.addEventListener('resize', (e) => {
      console.log('New sizes:', e.detail);
    });

Troubleshooting

How do I make panels collapsible?
Add collapsible: true to the panel configuration in dataSource.
How do I set minimum panel sizes?
Use min property in panel config: { size: '200px', min: '100px', content: '...' }.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Splitter, SplitterProps } from 'smart-webcomponents-react/splitter';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Splitter component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.